#ifdef CONFIG_VPROXY
#include <net/vproxy.h>
# if defined(SA_TCP_DEBUG) && !defined(CONFIG_ATM)
extern unsigned char sa_debug_global_flag;
/*
 * A similar socket debug macro exist is net/sock.h
 * SKB_DEBUG() unfortunatly is also defined by some
 * CONFIG_ATM code; might switch to SA_SKB_DEBUG().
 */
#  define SKB_DEBUG(skb, msg...)                                                            \
        do {                                                                                \
                if (sa_debug_global_flag && (skb) != NULL) {                                \
                        if ((skb)->vdata.vproxy_flags & PROXY_PACKET ) {                    \
                                if (function_entry(msg)) {                                  \
                                        printk(KERN_DEBUG "%s", __func__);    /* Entry */   \
                                } else {                                                    \
                                        printk(KERN_DEBUG "%s: ", __func__);                \
                                }                                                           \
                                printk(msg);                                                \
                        }                                                                   \
                }                                                                           \
        } while (0)
# else /* !SA_TCP_DEBUG */
# else /* !CONFIG_VPROXY */
# define SKB_DEBUG(sk, msg...) do { } while (0)
#endif /* CONFIG_VPROXY */
