# ifdef SA_TCP_DEBUG
/*
 *  A similar socket debug macro exist is net/core/skbuff.h
 */
extern unsigned char sa_debug_global_flag;

#if 0
#   define SA_DEBUG(msg...)                                                                                \
    do {                                                                                                   \
                if (sa_debug_global_flag) {                                                                \
                        printk(KERN_DEBUG "%s: ", __func__);                                               \
                        printk(msg);                                                                       \
                }                                                                                          \
        } while (0)
#  endif 

#  define SOCK_DEBUG(sk, msg...)                                                                           \
        do {                                                                                               \
                if (sa_debug_global_flag && (sk) != NULL) {                                                \
                        if ((sk)->socket_type || (sk)->vproxy_id || (sock_flag((sk), SOCK_DBG) )) {        \
                                if (function_entry(msg)) {                                                 \
                                    printk(KERN_DEBUG "%s", __func__);    /* Function Entry */             \
                                } else {                                                                   \
                                    printk(KERN_DEBUG "%s: ", __func__);                                   \
                                }                                                                          \
                                printk(msg);                                                               \
                        }                                                                                  \
                }                                                                                          \
        } while (0)

#  define SOCK_ERR(sk, msg...)                                                                             \
        do {                                                                                               \
                if (sa_debug_global_flag && (sk) != NULL) {                                                \
                        if ((sk)->socket_type || (sk)->vproxy_id || (sock_flag((sk), SOCK_DBG) )) {        \
                                printk(KERN_ERR "%s: ", __func__);                                         \
                                printk(msg);                                                               \
                        }                                                                                  \
                }                                                                                          \
        } while (0)

#  define TCP_SOCK_DEBUG(tp, msg...)                                                                       \
        do {                                                                                               \
                struct sock *sk = &tp->inet.sk;                                                            \
                                                                                                           \
                if (sa_debug_global_flag && (sk) != NULL) {                                                \
                        if ((sk)->socket_type || (sk)->vproxy_id || (sock_flag((sk), SOCK_DBG) )) {        \
                                if (function_entry(msg)) {                                                 \
                                     printk(KERN_DEBUG "%s", __func__);    /* Function Entry */            \
                                } else {                                                                   \
                                    printk(KERN_DEBUG "%s: ", __func__);                                   \
                                }                                                                          \
                                printk(msg);                                                               \
                        }                                                                                  \
                }                                                                                          \
        } while (0)

#  define TW_SOCK_DEBUG(tw, msg...)                                                                        \
        do {                                                                                               \
                if (sa_debug_global_flag && (tw) != NULL) {                                                \
                        if ((tw)->socket_type || (tw)->vproxy_id) {                                        \
                                if (function_entry(msg)) {                                                 \
                                    printk(KERN_DEBUG "%s", __func__);  /* Function Entry */               \
                                } else {                                                                   \
                                    printk(KERN_DEBUG "%s: ", __func__);                                   \
                                }                                                                          \
                                printk(msg);                                                               \
                        }                                                                                  \
                }                                                                                          \
        } while (0)

# else /* !SA_TCP_DEBUG */

#  define SOCK_DEBUG(sk, msg...)                                                                           \
        do { if ((sk) && sock_flag((sk), SOCK_DBG))                                                        \
                        printk(KERN_DEBUG msg);                                                            \
        } while (0)

#  define SOCK_ERR(sk, msg...) 		do { } while (0)
// #  define SA_DEBUG(tp, msg...) 	do { } while (0)
#  define TCP_SOCK_DEBUG(tp, msg...) 	do { } while (0)
#  define TW_SOCK_DEBUG(tw, msg...) 	do { } while (0)
# endif /* SA_TCP_DEBUG */

#else /* !SOCK_DEBUGGING */

// # define SA_DEBUG(sk, msg...) 	do { } while (0)
# define SOCK_DEBUG(sk, msg...) 	do { } while (0)
# define SOCK_ERR(sk, msg...) 		do { } while (0)
# define TCP_SOCK_DEBUG(tp, msg...) 	do { } while (0)
# define TW_SOCK_DEBUG(tw, msg...) 	do { } while (0)
#endif /* SOCK_DEBUGGING */
